//+------------------------------------------------------------------+
//|                             YURAZ_CreaHistorCSVFromMT5forMT4.mq5 |
//|            Copyright 2010, MetaQuotes Software Corp. (C) & YURAZ |
//|                                            www.masterforex-v.org |
//+------------------------------------------------------------------+
//
//  CSV   M1,    4.
//    4     ,   2010 ,
//        2010    2010
//     MT5   

#property copyright "Copyright 2010, MetaQuotes Software Corp. & (C) YURAZ"
#property link      "www.masterforex-v.org"
#property version   "1.00"
#include <Files\File.mqh>
#include <Files\FileTxt.mqh>

string    ExtFileName; // ="XXXXXX_PERIOD.CSV";
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void  OnStart()
  {
  
//---  ,    " "
   int symbols=SymbolsTotal(true);
//---      
   for(int s=0;s<symbols;s++)
   for(int t=0;t<9;t++){
    Alert(SymbolName(s,true)+"  "+EnumToString( PeriodTo4(t)));
      create(SymbolName(s,true), PeriodTo4(t));
   }



  }
void create(string symb, ENUM_TIMEFRAMES tfr){
   CFileTxt     *File;
   MqlRates  rates_array[];
   string sSymbol=symb;
   string  sPeriod;
   PeriodToStr(tfr,sPeriod);

   Comment("... ... "+symb+" "+EnumToString(tfr));
//    EURUSD1 
   ExtFileName=sSymbol;
   StringConcatenate(ExtFileName,sSymbol,"_",sPeriod,".CSV");
   ArraySetAsSeries(rates_array,true);
   int iMaxBar=TerminalInfoInteger(TERMINAL_MAXBARS);
   string format="%G,%G,%G,%G,%d";
   int iCod=CopyRates(sSymbol,tfr,0,iMaxBar,rates_array);
   if(iCod>1)
     {
      File=new CFileTxt;
      if(File==NULL)
        {
         //---   
         printf("%s (%4d): creating error",__FILE__,__LINE__);
         return;
        }
      //  
      File.Open(ExtFileName,FILE_WRITE,9);
      for(int i=iCod-1; i>0; i--)
        {
         //   
         // 2009.01.05,12:49,1.36770,1.36780,1.36760,1.36760,8
         string sOut=StringFormat("%s",TimeToString(rates_array[i].time,TIME_DATE));
         sOut=sOut+","+TimeToString(rates_array[i].time,TIME_MINUTES);
         sOut=sOut+","+StringFormat(format,
                                    rates_array[i].open,
                                    rates_array[i].high,
                                    rates_array[i].low,
                                    rates_array[i].close,
                                    rates_array[i].tick_volume);
         sOut=sOut+"\n";
         File.WriteString(sOut);
        }
      File.Close();
     }
   Comment("OK. ... ");
}
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
bool PeriodToStr(ENUM_TIMEFRAMES period,string &strper)
  {
   bool res=true;
//---
   switch(period)
     {
      case PERIOD_MN1 : strper="MN1"; break;
      case PERIOD_W1 :  strper="W1";  break;
      case PERIOD_D1 :  strper="D1";  break;
      case PERIOD_H1 :  strper="H1";  break;
      case PERIOD_H2 :  strper="H2";  break;
      case PERIOD_H3 :  strper="H3";  break;
      case PERIOD_H4 :  strper="H4";  break;
      case PERIOD_H6 :  strper="H6";  break;
      case PERIOD_H8 :  strper="H8";  break;
      case PERIOD_H12 : strper="H12"; break;
      case PERIOD_M1 :  strper="M1";  break;
      case PERIOD_M2 :  strper="M2";  break;
      case PERIOD_M3 :  strper="M3";  break;
      case PERIOD_M4 :  strper="M4";  break;
      case PERIOD_M5 :  strper="M5";  break;
      case PERIOD_M6 :  strper="M6";  break;
      case PERIOD_M10 : strper="M10"; break;
      case PERIOD_M12 : strper="M12"; break;
      case PERIOD_M15 : strper="M15"; break;
      case PERIOD_M20 : strper="M20"; break;
      case PERIOD_M30 : strper="M30"; break;
      default : res=false;
     }
//---
   return(res);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
ENUM_TIMEFRAMES PeriodTo4(int p)
  {
   switch(p)
     {
      case 0 :  return(PERIOD_M1);
      case 1 :  return(PERIOD_M5);
      case 2 :  return(PERIOD_M15);
      case 3 :  return(PERIOD_M30);
      case 4 :  return(PERIOD_H1);
      case 5 :  return(PERIOD_H4);
      case 6 :  return(PERIOD_D1);
      case 7 :  return(PERIOD_W1);
      case 8 :  return(PERIOD_MN1);
     }
//---
   return(PERIOD_M1);
  }
//+------------------------------------------------------------------+